
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>hibernate注解映射属性 / 憋错料</title>

    <meta name="description" content="hibernate注解映射属性 https://blog.csdn.net/dada678/article/details/51786201 1.普通属性 @Entity:修饰的持久化类的所有属性都会被映射到底层数据库. @Column:修饰属性 @Transient:修饰不想持久化保存的属性. @Lob:修饰大数据属性. 当属性为byte[].Byte[]时数据库对应Blob 当属性为char[].character[].String时,对应为Clob. @Temporal修饰日期类型 支持TemporalType.DATE">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">hibernate注解映射属性</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>https://blog.csdn.net/dada678/article/details/51786201</p>
<p>1、普通属性</p>
<p>@Entity：修饰的持久化类的所有属性都会被映射到底层数据库。</p>
<p>@Column:修饰属性</p>
<p>@Transient：修饰不想持久化保存的属性。</p>
<p>@Lob:修饰大数据属性。</p>
<p>当属性为byte[]、Byte[]时数据库对应Blob</p>
<p>当属性为char[]、character[]、String时，对应为Clob.</p>
<p>@Temporal修饰日期类型</p>
<p>支持TemporalType.DATE、TemporalType.TIME、TemporalType.TIMESTAMP</p>
<p>@GenericGenerator注解主键生成器 &nbsp;name strategy</p>
<p>例如：</p>
<p>@GenericGenerator(name="fk_hilo",strategy="hilo" ) &nbsp; &nbsp;//指定主键生成策略为hilo</p>
<p>@GeneratedValue(generator="fk_hilo") &nbsp; &nbsp; //使用该主键生成策略</p>
<p>2、映射集合属性</p>
<p>集合分为两种类型：一、List、Set、数组</p>
<h1>二、Map</h1>
<p>hibernate要求持久化集合值字段必须声明为接口。</p>
<p>不论哪种集合，统一使用@ElementCollection注释</p>
<p>属性fetch指定抓取策略 &nbsp; targetClass:指定集合类型。</p>
<p>外键列@JoinColumn</p>
<p>当集合元素为基础数据类型时，用@Column注释定义集合元素即可</p>
<p>@OrderColumn可以定义List集合、数组的索引列</p>
<p>@MapKeyColumn用于映射Map集合的索引列</p>
<h1>例如：数组、list集合可以这样写</h1>
<p>@ElementCollection(targetClass=String.class) &nbsp; //集合属性保存对象关联关系</p>
<p>@CollectionTable(name="school_inf",[email&#160;protected](name="person_id",nullable=false)) &nbsp;//映射保存集合属性的表</p>
<p>@Column(name="school_name") &nbsp; &nbsp;//指定保存集合元素的列为school_name</p>
<p>@OrderColumn(name="array_order") &nbsp; //映射集合的索引列【数组的写法】</p>
<p>@OrderColumn(name="list_order")　　//映射保存集合元索引列</p>
<p>private String[] schools;</p>
<p>private List&lt;String&gt; schools = new ArrayList&lt;&gt;();</p>
<h1>例如：set集合，set集合无序，所以不用写OrderColumn</h1>
<p>&lt;list name="school_name" table="school_inf"&gt;</p>
<p>&lt;key&gt;</p>
<p>&lt;column name="person_id" not-null="true"/&gt;</p>
<p>&lt;/key&gt;</p>
<p>&lt;list-index&gt;</p>
<p>&lt;column name="array_order"/&gt;</p>
<p>&lt;list-index&gt;</p>
<p>&lt;element type="String" column="school_name"&gt;&lt;/element&gt;</p>
<p>&lt;/list&gt;</p>
<p>例如：</p>
<p>@ElementCollection(targetClass=String.class) &nbsp; //集合属性保存对象关联关系</p>
<p>@CollectionTable(name="school_inf",[email&#160;protected](name="person_id",nullable=false)) &nbsp;//映射保存集合属性的表,nullable=false说明该列为非空。</p>
<p>@Column(name="school_name",nullable=faluse) &nbsp; &nbsp;//指定保存集合元素的列为school_name</p>
<p>private Set&lt;String&gt; schools;</p>
<p>&lt;set name="school_name" table="school_inf" &gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;key&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;column name="person_id"&nbsp; not-null="true" /&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/key&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;element type="string" column="school_name"&gt;&lt;/element&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;/set&gt;</p>
<p>例如：</p>
<h1>List集合</h1>
<p>@ElementCollection(targetClass=Float.class) &nbsp; //集合属性保存对象关联关系</p>
<p>@CollectionTable(name="score_inf",[email&#160;protected](name="person_id",nullable=false)) &nbsp;//映射保存集合属性的表,nullable=false说明该列为非空。</p>
<p>@MapKeyColumn(name="subject_name") //指定Map Key</p>
<p>@Column(name="mark") &nbsp; &nbsp;//指定保存集合元素的列为school_name</p>
<p>@OrderColumn(name="list_order")　　//映射保存集合元索引列</p>
<h1>Map集合属性</h1>
<p>@ElementCollection(targetClass=Float.class)<br />	//映射保存集合属性的表<br />	@CollectionTable(name="score_inf",//指定表名<br />	[email&#160;protected](name= "person_id",nullable=false))<br />	@MapKeyColumn(name="subject_name")<br />	//指定Mapkey的类型为String类型<br />	@MapKeyClass(String.class)<br />	//映射保存MapValue的数据列<br />	@Column(name="mark")<br />	private Map&lt;String, Float&gt; scores = new HashMap&lt;&gt;();</p>
<h1>3、集合属性性能分析</h1>
<p>在初始化持久化实体时，立即抓取所有的集合属性，将导致性能急剧下降，对于集合属性，通常使用延时加载策略。</p>
<p>@ElementCollection(fetch=FetchType.EAGER)</p>
<p>无序集合只能遍历，性能差</p>
<p>虽然数组也是有序结合，但是数据无法使用延时加载（因为数组长度不可变），所以实际上用数组作为集合性能并不高，通常认为List、Map集合性能较高，而</p>
<p>Set紧随其后</p>
<p>提高性能的策略：</p>
<p>对于删除集合中的元素，保留部分元素的情况，应该先清空集合，再插入保留元素。</p>
<p>List&lt;String&gt; tmp=person.getSchools();</p>
<p>person.setSchools(null); &nbsp;//清空操作</p>
<p>person.setSchools(tmp);</p>
<h1>4、有序集合映射</h1>
<p>如果希望数据库查询自己对集合元素排序，可以利用Hibernate自己提供的@OrderBy注解</p>
<p>1</p>
<p>@OrderBy("traing_name desc");</p>
<p>2</p>
<p>//有序集合属性<br />	@ElementCollection(targetClass=String.class)<br />	//映射保存集合元素的<br />	@CollectionTable([email&#160;protected]"training_inf",[email&#160;protected](name="person_id",nullable=false))<br />	//定义保存集合元素的数据列<br />	@Column(name="training_name",nullable=false)<br />	//使用@SortNatural指定使用自然排序<br />	@SortNatural<br />	private SortedSet&lt;String&gt;trainings = new TreeSet&lt;&gt;();</p>
<h1>5、映射数据库对象</h1>
<p>如果希望在映射文件中创建和删除触发器，存储过程等数据库对象，hibernate提供了&lt;database-object/&gt;元素来满足这种需求</p>
<p>1.在映射文件显示生命create和drop命令</p>
<p>&lt;hibernate-mapping&gt;</p>
<p>　　</p>
<p>　　&lt;database-object&gt;</p>
<p>　　　&lt;create&gt;create trigger t_full_conent_gen ..&lt;/create&gt;</p>
<p>　　　&lt;drop&gt;create trigger t_full_content_gen&lt;/drop&gt;</p>
<p>　　　　&lt;!----指定某些数据库仅在特定的方言中使用---&gt;</p>
<p>　　　　&lt;!---指定仅对MySQL数据库有效--&gt;</p>
<p>　　　　&lt;dialect-scope name="org.hibernate.dialect.MySQL5Dialect"/&gt;</p>
<p>　　　　&lt;dialect-scope name="org.hibernate.dialect.MySQL5InnoDBDialect"/&gt;</p>
<p>　　&lt;/database-object&gt;</p>
<p>&lt;/hibernate-mapping&gt;</p>
<p>2.提供一个类，这个类组织create和drop命令 这个类必须实现org.hibernate.mapping.AuxiliaryDatabaseObject接口</p>
<p>&lt;hibernate-mapping&gt;</p>
<p>　　</p>
<p>　　&lt;database-object&gt;</p>
<p>　　　&lt;definition class="MyTriggerDefinition"&gt;</p>
<p>　　&lt;/database-object&gt;</p>
<p>&lt;/hibernate-mapping&gt;</p>
<p>&lt;database-object&gt;</p>
<p>　　&lt;create&gt;create table test(t_name varchar(255))&lt;/create&gt;</p>
<p>　　&lt;!--指定仅对特定方言有效--&gt;</p>
<p>　　&lt;dialect-scope name="org........"/&gt;</p>
<p>&lt;/database-object&gt;</p>
<p>这样在创建sessionFactory对象时，上面代码就生效了，数据库中就新建了test表。</p>
<p>Hibernate提供了schemaExport工具，生成数据库对象。[仅根据映射文件来生成数据库对象]</p>
<p>Configuration conf=new Configuration().configure();</p>
<p>SchemaExport se=new SchemaExport(conf);</p>
<p>se.setFormat(true) &nbsp; //格式化sql</p>
<p>.setOutputFile("news.sql") &nbsp; &nbsp;//设置保存sql脚本的文件</p>
<p>.create(true,true); &nbsp;//输入sql脚本并执行</p>
<p>//////SchemaExport工具类&nbsp;&nbsp;　　使用java命令来解释执行工具类&nbsp; &nbsp;命令格式如下</p>
<p>java -cp hibernate_classpaths org.hibernate.toolw.hbm2ddl.SchemaExport options mapping_files</p>
<h1>6、映射组件属性：</h1>
<p>持久化类属性并不是基础数据类型，例如privte Name name;</p>
<p>一、可以用@Embeddable注释Name类，作为组件使用，用@Parent修饰该属性。（修饰Name里的 private Person owner）</p>
<p>二、直接在Person实体类中，包含一个组件类型（Name类）</p>
<p>1.</p>
<p>@Embeddable</p>
<p>class Name{</p>
<p>　　//引用拥有该Name的Person对象</p>
<p>@Parent　</p>
<p>private Person owner;</p>
<p>}</p>
<p>class Person{</p>
<p>//Name组件</p>
<p>　　private Name name;</p>
<p>}</p>
<p>2.class Person{</p>
<p>　　//主键属性Name</p>
<p>　　@Embedded</p>
<p>　　@AttributeOverrides({</p>
<p>　　@AttributeOverride(name="first",[email&#160;protected](name="person_firstname")),</p>
<p>　　@AttributeOverride(name="last",[email&#160;protected](name="person_lastname")),</p>
<p>})</p>
<p>}</p>
<p>3.组件属性为集合</p>
<p>class Name{</p>
<p>　@ElementCollection(targetClass=Integer.class)</p>
<p>　　@CollecitonTable(name="power_inf",[email&#160;protected](name="person_name_id",nullable=false))</p>
<p>　　@MapKeyColumn(name="power_inf")////////////</p>
<p>　　@Column(name="name_power",nullable=false)</p>
<p>　　@MapKeyClass(String.class)</p>
<p>　　prvate Map&lt;String,Integer&gt; power = new HashMap&lt;&gt;();</p>
<p>　　@OrderColumn(name="power_inf")/////</p>
<p>　　private List&lt;String&gt; power = new ArraryList&lt;&gt;();</p>
<p>}</p>
<p>4.集合属性的元素为组件</p>
<p>@Embeddable</p>
<p>class Name{}</p>
<p>@Entity</p>
<p>@Table(name="person_inf")</p>
<p>class Person{</p>
<p>　　//Map集合元素是组件</p>
<p>　　@ElementCollection(TargetClass=Score.class)</p>
<p>　　@CollectionTable(name="score_inf",[email&#160;protected](name="person_id",nullable=false))</p>
<p>　　@MapKeyColumn(name="subject_name")　　</p>
<p>　　@MapKeyClass(String.class)</p>
<p>　　private Map&lt;String,Score&gt;scores = new HashMap&lt;&gt;();</p>
<p>　　//List集合元素是组件</p>
<p>　　@ElementColleciton(TargetClass=Name.class)</p>
<p>　　@CollectionTable(name="nick_inf",[email&#160;protected](name="person_id",nullable=false))</p>
<p>　　@OrderColumn(name="list_order")</p>
<p>　　private List&lt;Name&gt; nicks = new ArrayList&lt;&gt;();</p>
<p>}</p>
<p>5.组件作为Map的索引</p>
<p>@Embeddable</p>
<p>class Name{</p>
<p>　　//重写equals 和 hasCode方法</p>
<p>　　public boolean equals(Object obj)</p>
<p>　　{</p>
<p>　　　　if (this == obj)</p>
<p>　　　　{</p>
<p>　　　　　　return true;</p>
<p>　　　　}</p>
<p>　　　　if (obj != null &amp;&amp; obj.getClass() == Name.class) {</p>
<p>　　　　　　Name target = (Name)obj;</p>
<p>　　　　　　//属性值比较 自定义属性的比较</p>
<p>　　　　　　return target.getFirst().equals(getFirst()) &amp;&amp;&nbsp; target.getLast().equals(getLast);</p>
<p>　　　　}</p>
<p>　　}</p>
<p>　　//　重写HasCode（）方法， 根据first、last计算hashCode值</p>
<p>　　retun getFirst().hasCode* 31 + getLast().hasCode();</p>
<p>}</p>
<p>@Enitity</p>
<p>@Table()</p>
<p>class Person{</p>
<p>　　//集合属性nickPower</p>
<p>　　@ElementColleciton(targetClass=Integer.class)</p>
<p>　　@CollectionTable(name="nbick_power_inf",[email&#160;protected](name="person_id",nullable=false))</p>
<p>　　@Column(name="nick_power",nullable=false)</p>
<p>　　@MapKeyClass(Name.class)//指定mapKey的类型</p>
<p>}</p>
<p>7.组件作为符合主键</p>
<p>class Name implements java.io.Serializable{</p>
<p>　　//重写equal（）和 hashCode（）</p>
<p>}</p>
<p>@Entity</p>
<p>@Table(name="")</p>
<p>class Person{</p>
<p>　　//以Name组件作为标识属性&nbsp; &nbsp; 用法同@Embedded&nbsp; &nbsp; &nbsp;@Embedded用于修饰普通的组件属性</p>
<p>　　//@EmbeddedId用于修饰组件类型的组件 同样可以结合@AttributeOverrides 和@AttributeOverride两个注释</p>
<p>　　@EmbeddedId</p>
<p>　　@AttributeOverrides({</p>
<p>　　　　//指定 组件内各属性与底层数据列之间的映射</p>
<p>　　　　@AtributeOverride(name="first",[email&#160;protected](name="person_firstname"))</p>
<p>　　　　@AtributeOverride(name="last",[email&#160;protected](name="person_lastname"))</p>
<p>　　　　})</p>
<p>}</p>
<p>8.多列作为联合主键</p>
<p>持久化类必须满足</p>
<p>1）无参数的构造器&nbsp; &nbsp;2）实现java.io.Serializable&nbsp; 3)联合主键所映射的属性重写equals（）和 hashCode（）</p>
<p>@Entity</p>
<p>@Table(name="")</p>
<p>class Person{</p>
<p>　　　　//使用联合主键 只需要使用@Id修饰两个成员变量即可</p>
<p>　　@Id</p>
<p>　　prvate String first;</p>
<p>　　@Id</p>
<p>　　private String last;</p>
<p>　　//重写Equals（）方法 和 hashCode（）方法</p>
<p>　　</p>
<p>}<br />---------------------</p>
<p>原文：https://blog.csdn.net/dada678/article/details/51786201 <br />版权声明：本文为博主原创文章，转载请附上博文链接！</p>
<p>9使用xml映射符合主键</p>
<p>在person.hbm.xml中</p>
<p>&lt;hibernate-configuration&gt;</p>
<p>　　</p>
<p>&lt;class name="Person" table="person_inf"&gt;<br /> 		　　&lt;!--映射组件类型的标识属性,映射复合主键--&gt;<br /> 		　　&lt;composite-id name="name" class="Name"&gt;<br /> 			　　　　&lt;!--映射符合主键里的各个属性--&gt;<br /> 			　　　　&lt;key-property name="first" type="string"/&gt;<br /> 			　　　　&lt;key-property name="last" type="string"/&gt;<br /> 		　　&lt;/composite-id&gt;<br /> 		　　&lt;!--映射普通属性--&gt;<br /> 		　　&lt;property name="email" type="string"&gt;<br /> 		　　&lt;!--映射组件属性cat，组件属性的类型为Cat--&gt;<br /> 		　　&lt;component&gt;<br /> 			　　　　&lt;!--指定owner属性代表容器实体--&gt;<br /> 			　　　　&lt;parent name="owner"/&gt;<br /> 			　　　　&lt;!--映射组件属性的fisrt属性--&gt;<br /> 			　　　　&lt;property name="name" column="cat_name"/&gt;<br /> 			　　　　&lt;!--映射组件属性的last属性--&gt;<br /> 			　　　　&lt;property name="color" column="cat_color"/&gt;<br /> 		　　&lt;/component&gt;<br /> 	　　&lt;/class&gt;</p>
<p>&lt;/hibernate-configuration&gt;</p>
<p>Hibernate提供了如下三种方式将POJO变成PO类。</p>
<p>1使用持久化注解(以JPA标准注解为主,如果有一些特殊要求,则依然需要使用 Hibernate本身提供的注解</p>
<p>种方式可以</p>
<p>2使用JPA2提供的XML配置描述文件(XML deployment descriptor)，使用这种方式可以让Hibernate的PO类与JPA实体类兼容。</p>
<p>3使用 Hibernate传统的XML映射文件(* hbm. xml文件的形式),由于这种方式是传统 Hibernate</p>
<p>对于 Hibernate PO类而言,通常可以采用如下两个注解来修饰它。</p>
<p>@ Entity:被该注解修饰的POJO就是一个实体。使用该注解时可指定一个name属性,name属性指定该实体类的名称,但大部分时候无须指定该属性,因为系统默认以该类的类名作为实体类的名称</p>
<p>@ Table::该注解指定持久化类所映射的表。</p>
<p>使用Table注解可指定如表52所示的属性</p>
<table>
<tbody>
<tr>
<td>
<br />属性</p>
</td>
<td>
<br />是否必须</p>
</td>
<td>
<br />说明</p>
</td>
</tr>
<tr>
<td>
<br />catalog</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />设置将持久化类映射的表放入指定的 catalog中,如果没有指定该属性,数据表将放入默认的 catalog中</p>
</td>
</tr>
<tr>
<td>
<br />indexes</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />为持久化类所映射的表设置索引。该属性的值是一个@Index注解数组</p>
</td>
</tr>
<tr>
<td>
<br />name</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />设置持久化类所映射的表的表名。如果没有指定该属性,那么该表的表名将与持</p>
<p>久化类的类名相同</p>
</td>
</tr>
<tr>
<td>
<br />schema</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />设置将持久化类所映射的表放入指定的 schema中。如果没有指定该属性，数据表将放入默认的schema中</p>
</td>
</tr>
<tr>
<td>
<br />uniqueConstraints</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />为持久化类所映射的表设置唯一约束。该属性的值是一个@ UniqueConstraint注解数组</p>
</td>
</tr>
</tbody>
</table>
<p>@UniqueConstraint用于为数据表定义唯一约束。它的用法非常简单,使用该注解时可以指定如下唯一的属性</p>
<p>columnNames</p>
<p>该属性的值是一个字符串数组,每个字符串元素代表一个数据列</p>
<p>@Index用于为数据表定义索引。该注解可指定如表53所示的属性。</p>
<table>
<tbody>
<tr>
<td>
<br />属性</p>
</td>
<td>
<br />是否必须</p>
</td>
<td>
<br />说明</p>
</td>
</tr>
<tr>
<td>
<br />columnList</p>
</td>
<td>
<br />是</p>
</td>
<td>
<br />设置对哪些列建立索引,该属性的值可指定多个数据列的列名</p>
</td>
</tr>
<tr>
<td>
<br />name</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />置该索引的名字</p>
</td>
</tr>
<tr>
<td>
<br />unique</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />设置该索引是否具有唯一性。该属性的值只能是 boolean值</p>
</td>
</tr>
</tbody>
</table>
<p>如果希望改变 Hibernate的属性访问策略,则可使用标准的@ Access注解修改该持久化类,该注解的value属性支持 AccessType.PROPERTY和 Access.TypeFIELD两个值。其默认值为 AccessType PROPERTY,</p>
<p>即使用 getter/setter法访问属性两个方法</p>
<p>如果将@Acess注解的value指定为 AccessType FIELD, Hibernate将直接通过成员变量来访问属性。</p>
<p>除此之外, Hibernate还为持久化类提供了如下特殊的注解。</p>
<p>@ Proxy:该注解的 proxyClass属性指定一个接口,在延迟加载时作为代理使用,也可以在这里</p>
<p>指定该类自己的名字</p>
<p>@ DynamicInsert:指定用于插入记录的 Insert语句是否在运行时动态生成,并且只插入那些非空字段。该属性的值默认是 false。开启该属性将导致 Hibernate需要更多时间来生成SQL语句。</p>
<p>@ DynamicUpdate:指定用于更新记录的 update语句是否在运行时动态生成,并且只更新那些改变过的字段。该属性的值默认是 false。开启该属性将导致 Hibernate需要更多的时间来生成SOL语句</p>
<h2>提示</h2>
<p>程序打开了@ DynamicUpdate之后,持久化注解可以指定如下几种乐观锁定的策略</p>
<ol>
<li>OptimisticLockType.VERSION:检查 version/timestamp字段</li>
<li>OptimisticLockType.ALL:检查全部字段</li>
<li>OptimisticLockType.DIRTY:只检查修改过的字段</li>
<li>OptimisticLockType.NONE:不使用乐观锁定</li>
</ol>
<p>强烈建议在 Hibernate中使用 version/timestamp字段来进行乐观锁定。对性能来说,这是最妤的选择,并且也是唯一能够处理在 Session外进行脱管操作的策略。</p>
<p>@SelectBeforeUpdate:指定 Hibernate在更新( update)某个持久对象之前是否需要先进行一次查询(select)。如果将该注解的 value值设为ture,则 Hibernat可以保证只有当持久化对象的状态被修改过时,才会使用 update语句来保存其状态(即使程序显式使用 save OrUpdateO来保存该对象,但如果 Hibernate查询到对应记录与该持久化对象的状态相同,也不会使用update语句来保存其状态)。该注解的 value值默认为 false。通常来说,将@SelectBeforeUpdate的 value值设为ture会降低性能,如果应用程序中，某个持久化对象的状态经常会发生改变,那么该属性应该设置为 false;如果该持久化对象的状态很少发生改变,而程序又经常要保存该对象,则可将该属性设置为ture</p>
<p>@PolymorphismType:当采用 TABLE_PER_CLASS继承映射策略时,该注解用于指定是否需要采用隐式多态查询。该注解的 value的默认值为 PolymorphismType.IMPLICIT,即支持隐式多态查询</p>
<p>将@PolymorphismType的vaue值设为 PolymorphismType.IMPLICIT时,如果查询时给出的是任何超类、该类实现的接口或该类的名字,那么都会返回该类(及其子类)的实例;如果查询中给出的是子类的名字,则只返回子类的实例;否则,只有在查询时明确给出某个类名时,才会返回这个类的实例。大部分时候都需要使用隐式多态查询</p>
<p>@ Where:该注解的 clause属性可指定一个附加的SQL语句过滤条件(类似于添加 where子句),如果一旦指定了该注解,则不管采用load()、get()还是其他查询方法,只要试图加载该持久化类对象时,该 where条件就会生效。也就是说,只有符合该where条件的记录才会被加载。</p>
<p>@ BatchSize:当 Hibernate抓取集合属性或延迟加载的实体时,该注解的size属性指定每批抓取的实例数。</p>
<p>@OptimisticLocking该注解的type属性指定乐观锁定策略。 Hibernate支持OptimisticLockType.ALL、OptimisticLockType.DIRTY、 OptimisticLockType.NONE、 OptimisticLocklype.VERSION这4个枚举值默认值为 OptimisticLockType.VERSION</p>
<p>@ Check:该注解可通过 constraints指定一个SQL表达式,用于为该持久化类所对应的表指定一个 Check约束。</p>
<p>@ Subselect::该注解用于映射不可变的、只读实体。通俗地说,就是将数据库的子查询映射成Hibernate持久化对象。当需要使用视图(其实质就是一个查询)来代替数据表时,该注解比较有用</p>
<p>在默认情况下,被@Entity修饰的持久化类的所有属性都会被映射到底层数据表,为了指定某个属性映射的数据列的详细信息,如列名、列字段长度等,可以在实体类中使用@Column修饰该属性</p>
<p>使用@ Column时可指定如表所示的常用属性</p>
<table>
<tbody>
<tr>
<td>
<br />属性</p>
</td>
<td>
<br />是否必须</p>
</td>
<td>
<br />说明</p>
</td>
</tr>
<tr>
<td>
<br />columnDefinition</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />属性的值是一个代表列定义的SQL字符串(列名后面部分),指定创建该数据列的SQL语句</p>
</td>
</tr>
<tr>
<td>
<br />insertable</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />指定该列是否包含在围生成的insert语句列表中,默认值true</p>
</td>
</tr>
<tr>
<td>
<br />length</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />指定列所能保存的数据的最大长度,默认值:255</p>
</td>
</tr>
<tr>
<td>
<br />name</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />指定该列的列名,该到的列名默认与Coum修饰的成员变量名相同</p>
</td>
</tr>
<tr>
<td>
<br />nullable</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />指定该列是否允许为null.默认值:true</p>
</td>
</tr>
<tr>
<td>
<br />precision</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />当该列是 decimal类型时,该属性指定该列最大支持的最大有效数字位</p>
</td>
</tr>
<tr>
<td>
<br />scale</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />当该列是 decimal类型时,该属性指定该列最大支持的小数位数</p>
</td>
</tr>
<tr>
<td>
<br />table</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />指定该列所属的表名,当需要用多个表来保存一个实体时,需要指定</p>
</td>
</tr>
<tr>
<td>
<br />unique</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />指定列是否具有准一的束,默认值为false,即不具有唯一约束</p>
</td>
</tr>
<tr>
<td>
<br />updatable</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />指定该列是否包含在 Hibemate生成的update语句的列到表中,默认值true</p>
</td>
</tr>
</tbody>
</table>
<p>Hiberate同样允许使用 @Access注解修饰该属性,用于单独改变 Hibemate对该属性的访问策略@Access用于覆盖在持久化类上指定的 @Access注解除此之外, Hibemate还为属性映射提供了如下特殊的注解</p>
<p>@Formula该注解的value属性可指定一个SQL表达式,指定该属性的值将根据表达式来计算，持久化类对应的表中没有和计算属性对应的数据列----因为该属性值是动态计算出来的,无需保存到数据库</p>
<p>@Generated设置该属性映射的数据列的值是否由数据库生成,该注解的 value属性可以接受GerationTime.NEVER(不由数据库生成)、 GenerationTime.INSERT(该属性值在执行insert句时生成,但不会在执行update语句时重新生成)和 Generationtime.ALWAYS该属性值在执行insert和update语句时都会重新生成)这三不值的其中之一。</p>
<p>@Formula的 value属性允许对象属性包含表达式,包括运用sum、 average,mux函数求值的结果</p>
<p>va1ue=”(select avg(p.price) from Product p)”</p>
<p>@Formula甚至可以根据另外一个表的查询结果来计算当前记录的属性值,例如,下面代码把currency表查询的结果作为当前记录的计算属性值</p>
<p>Value="(select cus.same from currency cur where cur.id=curreneyID)"&gt;</p>
<p>使用 @Formula注解时有如下几个注意点</p>
<ol>
<li>value="(sql)"的英文括号不能少</li>
<li>value="(sql)"的括号里面是SOL表达式,SQL表达式中的列名与表名都应该和数据库对应,而不是和持久化对象的属性对应</li>
<li>如果需要在@Formula的value属性中使用参数,则直接使用 where cur.id= currencyID形式,其中 currencyID就是参数,当前持久化对象的 curreneyID属性将作为参数传入</li>
</ol>
<p><strong>import</strong> javax.persistence.Basic;</p>
<p><strong>import</strong> javax.persistence.Column;</p>
<p><strong>import</strong> javax.persistence.EnumType;</p>
<p><strong>import</strong> javax.persistence.Enumerated;</p>
<p><strong>import</strong> javax.persistence.FetchType;</p>
<p><strong>import</strong> javax.persistence.GeneratedValue;</p>
<p><strong>import</strong> javax.persistence.GenerationType;</p>
<p><strong>import</strong> javax.persistence.Id;</p>
<p><strong>import</strong> javax.persistence.Lob;</p>
<p><strong>import</strong> javax.persistence.Temporal;</p>
<p><strong>import</strong> javax.persistence.TemporalType;</p>
<p><strong>import</strong> javax.persistence.Transient;</p>
<p><strong>import</strong> javax.swing.JList.DropLocation;</p>
<p><strong>import</strong> org.hibernate.annotations.Formula;</p>
<p><strong>import</strong> org.hibernate.annotations.Generated;</p>
<p><strong>import</strong> org.hibernate.annotations.GenerationTime;</p>
<p><strong>public</strong> <strong>class</strong> News <strong>implements</strong> Serializable {</p>
<p><strong>public</strong> <strong>enum</strong> SeasonTime</p>
<p>{</p>
<p><strong><em>springTime</em></strong>,<strong><em>summer</em></strong>,<strong><em>fall</em></strong>,<strong><em>winter</em></strong></p>
<p>}</p>
<p>//使用@Enumerate修饰枚举</p>
<p>@Enumerated(EnumType.<strong><em>ORDINAL</em></strong>)</p>
<p>@Column(name="happen_season",length=50)//指定数据列表名称和长度&nbsp;&nbsp; 底层会保存数据序号来保存枚举值</p>
<p><strong>private</strong> SeasonTime happenSeason;</p>
<p>/***</p>
<p>* 使用@Lob、@Basic修饰大数据类型的属性</p>
<p>* 用于数据库保存图片、保存大段文章的场景，数据库通常采用Blob、Clob类型的数据列来保存他们；</p>
<p>* JDBC则采用java.sql.Blob、java.sql、Clob表示大数据类型</p>
<p>* Hibernate使用@Lob来修饰这种大数据类型</p>
<p>* 1.当持久化类的属性为byte[]、Byte[]或java.io.Serializable类型修饰的属性将映射为底层的Blob列</p>
<p>* 2.当持久化类的属性为char[]、Character[]或java.lang.Strign类型时，@Lob修饰的属性将映射为底层的Clob列</p>
<p>* 使用@Basic指定延迟加载，可以指定如下属性</p>
<p>* 1)fetch:指定是否延迟加载该属性。</p>
<p>* FetchType.EAGER立即加载、FetchType.LAZY延迟加载</p>
<p>* 2）optional:指定该属性映射的数据列是否允许使用null值</p>
<p>* **/</p>
<p>@Lob</p>
<p>@Basic(fetch=FetchType.<strong><em>LAZY</em></strong>)</p>
<p><strong>private</strong> <strong>byte</strong>[] pic;</p>
<p>/***</p>
<p>* <strong>@GeneratedValue</strong><strong>支持的属性</strong></p>
<p>* strategy 否&nbsp; 指Hibernate对该主键使用怎样的主键生成策略。该属性使用如下4个属性值</p>
<p>* 1）GenerationType.AUTO:Hibernate自动选择最适合底层数据库的主键生成策略。这是默认值</p>
<p>* 2）GenerationType.IDENTITY:对于MySQL、SQL Server这样的数据库，选择自增长这样的主键生成策略</p>
<p>* 3）GenerationType.SEQUENCE:对于Oracle数据库，选择使用基于Sequence的主键生成策略。</p>
<p>* 与@SequenceGennerator一起使用</p>
<p>* 4）GenerationType.TABLE:使用辅助表来生成主键。与@TableGenerator一起使用</p>
<p>* generator 否 当使用GeneatonType.SEQUENCE、GenerationType.TABLE主键生成策略时，</p>
<p>* 该属性引用@SequenceGenerator、@TableGenerator所定义的生成器的名称</p>
<p>* **/</p>
<p>@Id</p>
<p>@GeneratedValue(strategy=GenerationType.<strong><em>IDENTITY</em></strong>)</p>
<p><strong>private</strong> Integer id;</p>
<p><strong>private</strong> String title;</p>
<p><strong>private</strong> String autohor;</p>
<p>/***</p>
<p>* 使用@Temporal修饰日期类型的属性</p>
<p>* java.util.Date既包括日期部分，也包括时间部分；使用@Temporal(TemporalType.DATE)将该属性映射到date类型的数据列</p>
<p>* **/</p>
<p>@Temporal(TemporalType.<strong><em>DATE</em></strong>)</p>
<p><strong>private</strong> Date date;</p>
<p>//指定@Generated的value为ALWAYS,表明该属性的值由数据库生成</p>
<p>//Hibernate会在每次执行insert、update时执行select语句来查询获取该属性的值</p>
<p>//使用此属性需要数据库触发器支持</p>
<p>/**</p>
<p>* drop database hibernate;</p>
<p>create database hibernate;</p>
<p>use hibernate;</p>
<p>create table news</p>
<p>(</p>
<p>id int auto_increment primary key,</p>
<p>title varchar(255) not null,</p>
<p>content varchar(255),</p>
<p>full_content varchar(2555)</p>
<p>);</p>
<p>DELIMITER |</p>
<p>create trigger t_full_content_gen BEFORE INSERT ON&nbsp; news</p>
<p>FOR EACH ROW BEGIN</p>
<p>set new.full_content=concat(new.title,new.content);</p>
<p>END;</p>
<p>|</p>
<p>DELIMITTER;</p>
<p>* **/</p>
<p>@Generated(GenerationTime.<strong><em>ALWAYS</em></strong>)</p>
<p><strong>private</strong> String generContent;</p>
<p>//此属性由系统根据公式生成</p>
<p>@Formula("(select concat(nt.title,nt.autohor)"+"from NEWS nt where nt.id = id)")</p>
<p><strong>private</strong> String fullConent;</p>
<p>//使用@Transient修饰不想持久保存的属性</p>
<p>@Transient</p>
<p><strong>public</strong> Integer getId() {</p>
<p><strong>return</strong> id;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setId(Integer id) {</p>
<p><strong>this</strong>.id = id;</p>
<p>}</p>
<p><strong>public</strong> String getTitle() {</p>
<p><strong>return</strong> title;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setTitle(String title) {</p>
<p><strong>this</strong>.title = title;</p>
<p>}</p>
<p><strong>public</strong> String getAutohor() {</p>
<p><strong>return</strong> autohor;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setAutohor(String autohor) {</p>
<p><strong>this</strong>.autohor = autohor;</p>
<p>}</p>
<p><strong>public</strong> Date getDate() {</p>
<p><strong>return</strong> date;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setDate(Date date) {</p>
<p><strong>this</strong>.date = date;</p>
<p>}</p>
<p><strong>public</strong> News() {</p>
<p>//&nbsp;&nbsp; super();</p>
<p>// <strong>TODO</strong> Auto-generated constructor stub</p>
<p>}</p>
<p><strong>public</strong> News(String title, String autohor, Date date) {</p>
<p><strong>super</strong>();</p>
<p><strong>this</strong>.title = title;</p>
<p><strong>this</strong>.autohor = autohor;</p>
<p><strong>this</strong>.date = date;</p>
<p>}</p>
<p>@Override</p>
<p><strong>public</strong> String toString() {</p>
<p><strong>return</strong> "News [id=" + id + ", title=" + title + ", autohor=" + autohor + ", date=" + date + "]";</p>
<p>}</p>
<p>}</p>
<p>@SequenceGenerator支持的属性</p>
<table>
<tbody>
<tr>
<td>
<br />属性</p>
</td>
<td>
<br />是否必须</p>
</td>
<td>
<br />说明</p>
</td>
</tr>
<tr>
<td>
<br />name</p>
</td>
<td>
<br />是</p>
</td>
<td>
<br />该属性指定该主键生成器的名称</p>
</td>
</tr>
<tr>
<td>
<br />allocationSize</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定底层 Sequence每次生成主键值的个数,对于Oracle而言,该属性指定的整数值, 将作为定义 Sequence时 increment by的值</p>
</td>
</tr>
<tr>
<td>
<br />schema</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定将底层 Sequence放入指定shema中,如果不指定该属性,该 Sequence将放入默认的 schema中</p>
</td>
</tr>
<tr>
<td>
<br />catalog</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定将底层Sequence放入指定 catalog中,如果不指定该属性,该 Sequence将放入默catalog中</p>
</td>
</tr>
<tr>
<td>
<br />initialValue</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定底层Sequence的初始值。对于Oracle而言，该属性指定的整数值将作为定义Sequence时startwith的值</p>
</td>
</tr>
<tr>
<td>
<br />sequenceName</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定底层Sequnece的名称</p>
</td>
</tr>
</tbody>
</table>
<p>@TableGenerator支持的属性</p>
<table>
<tbody>
<tr>
<td>
<br />属性</p>
</td>
<td>
<br />是否必须</p>
</td>
<td>
<br />说明</p>
</td>
</tr>
<tr>
<td>
<br />name</p>
</td>
<td>
<br />是</p>
</td>
<td>
<br />该属性指定该主键生成器的名称</p>
</td>
</tr>
<tr>
<td>
<br />allocationSize</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定底层辅助表每次生成主键值的个数</p>
</td>
</tr>
<tr>
<td>
<br />catalog</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定将辅助表放入指定catalog中，如果不指定该属性，该辅助表将放入默认的catalog中</p>
</td>
</tr>
<tr>
<td>
<br />schema</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定将底层辅助表放入指定catalog中，如果不指定该属性，该辅助表将放入默认的schema中</p>
</td>
</tr>
<tr>
<td>
<br />table</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />指定辅助表的表明</p>
</td>
</tr>
<tr>
<td>
<br />initialValue</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定的整数值将作为辅助表的初始值。默认值：0</p>
</td>
</tr>
<tr>
<td>
<br />pkColumnName</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定存放主键名的列名</p>
</td>
</tr>
<tr>
<td>
<br />pkColumnValue</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定主键名</p>
</td>
</tr>
<tr>
<td>
<br />valueColumnValue</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性指定存放主键名的列名</p>
</td>
</tr>
<tr>
<td>
<br />indexes</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性值是一个@Index数组，用于为辅助表定义索引</p>
</td>
</tr>
<tr>
<td>
<br />uniqueConstraints</p>
</td>
<td>
<br />否</p>
</td>
<td>
<br />该属性值是一个@UniqueConstraint数组，用于为辅助表创建唯一约束</p>
</td>
</tr>
</tbody>
</table>
<h1>主键生成策略</h1>
<p>1.</p>
<p>@TableGenerator(name="newsGen",table="NEWS_ID_GEN",pkColumnName="gen_key",</p>
<p>valueColumnName="gen_value",pkColumnValue="news_id")</p>
<p>@TableGenerator(name="newsGen",table="NEWS_ID_GEN",</p>
<p>pkColumnName="gen_key",valueColumnName="gen_value",</p>
<p>pkColumnValue="news_id")</p>
<p>//使用GeneratedValue.TABLE主键生成策略</p>
<p>@GeneratedValue(strategy=GenerationType.<strong><em>TABLE</em></strong>,generator="newsGen")</p>
<h1>2.使用Hibernate的主键生成策略</h1>
<p>@GenericGenerator注解支持的属性</p>
<ol>
<li>name:必须属性指定主键生成器的名称，可以被@GeneratedValue的generator属性引用</li>
<li>strategy:必须属性。设置主键生成策略</li>
<li>Increment:主键类型long、short、int类型，只有在没有其他进程往同一表中插入数据时使用</li>
<li>Identity：DB2、MySQL、MicsortSQL Server、Sybase和HypersonicSQL等。主键类型long、short、Int类型</li>
<li>SequenceDB2、PostgreSQL、Oracle、SAPDB、McKoi等主键类型：long、short、int</li>
<li>Hilo：高低位高效算法long、short、int类型的标识符</li>
<li>seqhilo ：高低位高效算法long、short、int类型的标识符，需要给定一个Sequence的数据库名，如Oracle</li>
<li>uuid：128位UUID算法生成字符串类型的标识符号，UUID被编码为一个32位十六进制数的字符串</li>
<li>guid： 在MicsortSQLSever和MySQL中使用数据库生成GUID字符串</li>
<li>native： 根据底层数据库的能力选择identity、Sequence、或hilo中一个</li>
<li>assigned：让应用程序在save（）之前为对象分配一个标识符。相当于在不指定主键生成策略所采用默认策略</li>
<li>select： 通过数据库触发器选择某个唯一主键的行，并返回器主键值作为标识属性值</li>
<li>foreign： 直接使用另一个关联的对象的标识属性值、这种主键生成器只用于1-1关联</li>
</ol>

<p>原文地址：https://www.cnblogs.com/sundaysjava/p/10328299.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-23 01:58:54 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%a3%80%e6%9f%a5/" title="检查">检查</a>, <a href="https://www.biecuoliao.com/tag/ati/" title="ati">ati</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%84%e7%90%86/" title="处理">处理</a>, <a href="https://www.biecuoliao.com/tag/mbed/" title="mbed">mbed</a>, <a href="https://www.biecuoliao.com/tag/%e6%88%90%e5%91%98%e5%8f%98%e9%87%8f/" title="成员变量">成员变量</a>, <a href="https://www.biecuoliao.com/tag/%e8%af%a6%e7%bb%86%e4%bf%a1%e6%81%af/" title="详细信息">详细信息</a>, <a href="https://www.biecuoliao.com/tag/incr/" title="incr">incr</a>, <a href="https://www.biecuoliao.com/tag/scale/" title="scale">scale</a>, <a href="https://www.biecuoliao.com/tag/%e5%ad%97%e7%ac%a6%e4%b8%b2%e7%b1%bb/" title="字符串类">字符串类</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>hibernate注解映射属性的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nbnVo0.html" rel="bookmark">&lbrack;Hibernate&rsqb; 注解映射例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Hibernate 注解(Hibernate Annotation) 是一种比较新的方式,通过在 java 简单类增加注解,来声明 java 类和数据库表的映射,作用和 xml 文件相似.hibernate 注解可以用来增强,或者替换 xml 的映射声明方式. hibernate 注解功能需要使用下面三个 jar 文件 hibernate-annotations.jar ejb3-persistence.jar hibernate-commons-annotations.jar 代码的目录结构如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qxbr70.html" rel="bookmark">Hibernate注解映射联合主键的三种主要方式（转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://blog.csdn.net/robinpipi/article/details/7655388 联合主键用hibernate注解映射方式主要有三种:第一.将联合主键的字段单独放在一个类中,该类需要实现Java.io.Serializable接口并重写equals和hascode,再将该类注解为@Embeddable,最后在主类中(该类不包含联合主键类中的字段)保存该联合主键类的一个引用,并生成set和get方法,并将该引用注解为@Id 第二.将联合主键的字段单独放在一个类中,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLQDNB0.html" rel="bookmark">Hibernate注解映射联合主键的三种主要方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天在做项目的时候,一个中间表没有主键,所有在创建实体的时候也未加组件,结果报以下错误: org.springframework.beans.factory.BeanCreationException: Error creating bean with name 'hibernateSessionFactory' defined in class path resource [spring-config/ac-cif-srv-config.xml]: Invocation of init met			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vB91o3.html" rel="bookmark">hibernate注解映射继承关系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据库表 用户表(User) id username password 客户表(Customer),客户表id引用用户表id id phone 员工表(Employee),员工表id引用用户表id id qq 飞机表(Plane),飞机表包含客机和战斗机,客机有厕所,战斗机有武器 id type speed wc_position weapon_position 实体映射 //子类共享属性id,version @MappedSuperclass public abstract class Ide			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e6nVE3.html" rel="bookmark">SHOP&plus;&plus;  中Hibernate 注解 用法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近接触到一款JAVA开源软件(shop++)这是一款电商软件.然后看了这款软件的源代码,发现真的很强大.框架采用的是spring mvc + hibernate + freemarker ,代码结构层次分明,代码封装和重用性也很高.非常适合二次开发.其次重点说说hibernate 注解吧 数据库表采用的是hibernate注解映射的方式.然后略微研究了下,分享一下自己的见解. @Entity说明此类是一个实体映射 @Tabletable用来定义entity主表的name,cataloh,sch			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rk9874.html" rel="bookmark">hibernate之映射文件VS映射注解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 对于java开发者而言,注解应该不是一个陌生的概念,早在JavaSE阶段,例如@Override标记重写父类方法或实现接口方法,@Test标记单元测试方法,所以我们可以简单地把它理解为一种有特殊含义的标记...在开发过程中,我们还可以用注解方式替代配置文件实现相关功能,例如Java web开发中,3.0版本后,利用@WebServlet.@WebListener等注解分别可以替代web项目XML配置文件中相关内容.而本文中讲述的就是Hibernate的映射配置文件与映射注解的对比,这两种方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWvmnG4.html" rel="bookmark">1、Hibernate注解实现对象关联映射并自动生成数据库表</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				---恢复内容开始--- 前言:本例单独使用Hibernate框架通过Hibernate注解实现年级表和学生表的一对多关联并完成其级联操作 1.年级表 package pojo; import java.util.HashSet; import java.util.Set; import javax.persistence.CascadeType; import javax.persistence.Column; import javax.persistence.Entity; import j			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y2QwJ3.html" rel="bookmark">浅谈Hibernate中映射集合属性以及主键和外键</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先说明一下什么叫主键以及外键. 主键和外键是对于数据库来说的,数据库的表才有主键外键的说法. 主键:主键是指标识某个表中唯一且非空的一条记录行的列,这个列中的值不允许有重复的值,用于确定一个表中的一条记录,实际上主键就是告诉别人:这个数据列是唯一的. 外键:引用另外一个表中的主键,在当前表中不一定为唯一的,但是在被引用表中一般唯一.对于关系型数据库来说(比如MySQL)外键是联系数据表之间的唯一方式,主要目的是控制存储在外键表中的数据. 建立外键的前提:本表的列必须与外键类型相同(外键必须是外			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JKbrBM.html" rel="bookmark">Hibernate注解----关联映射注解以及课程总结详解----图片版本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇,记录了Hibernate注解----类级别注解以及属性注解详解 ,我们这一节主要讲解的是Hibernate注解----关联映射注解以及课程总结详解. 本节的主要内容: 第3章 关联映射注解 3-1 本章简介 3-2 实体之间的关系 3-3 一对一单向外键关联(一) 3-4 一对一单向外键关联(二) 3-5 一对一双向外键关联 3-6 一对一单向外键联合主键 3-7 多对一单向外键关联(一) 3-8 多对一单向外键关联(二) 3-9 一对多单向外键关联 3-9 一对多双向外键关联 3-10			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KazNr4.html" rel="bookmark" class="title">Linux常用命令&lpar;四&rpar; - mkdir</a>
					<div>
						linux mkdir 命令用来创建指定的名称的目录,要求创建目录的用户在当前目录中具有写权限,并且指定的目录名不能是当前目录中已有的目录. 1. 命令格式: mkdir  [选项]   目录 2.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ennXJ3.html" rel="bookmark" class="title">js判断某变量是不是字符串</a>
					<div>
						var str = 'asdf';? var str1 = new String('asdf'); typeof str;//&quot;string&quot; typeof str1;//&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRv1D4.html" rel="bookmark" class="title">QTP自动FlightReservation小程序，数据库被玩坏了~~~</a>
					<div>
						1.尝试使用CheckPointOnDataBase功能. 2.选中自带的数据库 3.执行Delete * from Orders; 如下图: 4.再次使用FlightReservation的时候,不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xRnZz4.html" rel="bookmark" class="title">&lbrack;疑难杂症&rsqb;解决实际开发中各种问题bug</a>
					<div>
						我有一个习惯就是遇到问题找到解决方案后收藏网页.后来遇到问题越来越多,收藏就多得有点离谱了.我反思了一下,其实有用的信息就那么点,那我干脆还是做成网页剪报好了. 关于VS的 Problem:未能正确加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7WZK3.html" rel="bookmark" class="title">centos7部署pyenv安装python多版本</a>
					<div>
						在CentOS7通过pyenv安装Python3和virtualenv CentOS中默认安装Python版本是2.7版.我们将一步步在CentOS服务器上的安装Python3. 由于CentOS系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWRVWM.html" rel="bookmark" class="title">【Linux笔记】ldconfig、ldd</a>
					<div>
						一.ldconfig ldconfig是一个动态链接库管理命令,为了让动态链接库为系统所共享,还需运行动态链接库的管理命令--ldconfig. ldconfig 命令的用途,主要是在默认搜寻目录(/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPPEBM.html" rel="bookmark" class="title">如何在 kernel 和 hal 层读取同一个标志</a>
					<div>
						很多时候我们需要从 HAL 层(Hardware Abstract Layer)传一个标志给 kernel 层.一般这种传递是不能直接通过定义全局变量来实现的. 此时可以通过读写文件来实现该标志. 譬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QwLae0.html" rel="bookmark" class="title">转 一篇关于sql server 三种恢复模式的文章，从sql server 的机制上来写的，感觉很不错，转了</a>
					<div>
						简介 SQL Server中的事务日志无疑是SQL Server中最重要的部分之一.因为SQL SERVER利用事务日志来确保持久性(Durability)和事务回滚(Rollback).从而还部分确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nYrJvM.html" rel="bookmark" class="title">【c语言】 编写一个函数实现n&Hat;k，使用递归实现</a>
					<div>
						//编写一个函数实现n^k,使用递归实现 #include &lt;stdio.h&gt; int cifang( int x, int y )//2^3=2*2*2 { int sum = 0; i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MERRkx0.html" rel="bookmark" class="title">Android 4&period;2 project导入 5&period;0 SDK Eclipse 开发环境出现的问题总结</a>
					<div>
						太阳火神的漂亮人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一致&quot;创作公用协议 转载请保留此句:太阳火神的漂亮人生 -   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZ7ayM.html" rel="bookmark" class="title">用XMODEM恢复cisco3550交换机的ios</a>
					<div>
						1.用控制线连接交换机console口与计算机串口1,用带有xmodem功能的终端软件连接(win2000 and xp的超级终端就带这功能). 2.设置连接方式为串口1(如果连接的是其他串口就选择其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NnAd84.html" rel="bookmark" class="title">多学一点（十五）&mdash;&mdash;为man命令添加颜色提示</a>
					<div>
						默认情况下,Linux中的man命令显示结果是不带颜色的,看起来交互性并不好.可以添加一些配置,为其添加一些颜色提示. 修改.bashrc文件: [[email protected] ~]# vim  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEW1ND3.html" rel="bookmark" class="title">ios开发－Object-C可变参数函数</a>
					<div>
						简介 一个可变参数函数是指一个函数拥有不定的参数,即为一个函数可接收多个参数.有时我们会遇到一些算术问题需要用到,比如是计算传入参数的总和,字符串的连接或是其它操作过程,我们在 OC 里也经常使用,最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBxyL4.html" rel="bookmark" class="title">postgresql的ALTER经常使用操作</a>
					<div>
						postgresql版本号:psql (9.3.4) 1.添加一列ALTER TABLE table_name ADD column_name datatype; 2.删除一列 ALTER TABLE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kl5qd3.html" rel="bookmark" class="title">Java集合中对象排序</a>
					<div>
						集合中的对象排序需求还是比较常见的,当然我们可以重写equals方法,循环比较:同时Java为我们提供了更易使用的APIs.当需要排序的集合或数组不是单纯的数字型时,通常可以使用Comparator或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPXmX6M.html" rel="bookmark" class="title">thinkphp5&period;0--验证</a>
					<div>
						我才知道原来验证有两种类型,独立验证和验证器,当然我们工作中肯定用验证器喽,代码的封装性也好很多,其实我觉得代码的维护性也好很多; 独立验证: //独立验证$data = [ 'name' =&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YLbJyM.html" rel="bookmark" class="title">二叉树的最小高度&comma;最大高度&lpar;深度&rpar;和宽度</a>
					<div>
						最大高度 function getMaxHeight(root){ if(root == null){ return 0; } else{ var left = getMaxHeight(root.l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kLeBP3.html" rel="bookmark" class="title">C编译器剖析&lowbar;5&period;2&period;4 中间代码生成及优化&lowbar;后缀表达式的翻译</a>
					<div>
						5.2.4 后缀表达式的翻译 在前面的章节中,我们介绍了用于对数组元素和结构体成员进行访问的函数Offset,其接口如下所示,参数addr代表了基地址,参数voff代表可变偏移,而参数coff则代表常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qqboW3.html" rel="bookmark" class="title">MFC中如何改装SDK的WinMain函数</a>
					<div>
						1.在TCHAR.H文件中定义了一个宏:#define _tWinMain WinMain这样MFC源代码在编译的时候,_tWinMain就会被替换为WinMain(),这样操作系统就可以调用了. 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eWDPw4.html" rel="bookmark" class="title">ready与load的区别</a>
					<div>
						JQuery里有ready和load事件 $(document).ready(function() { // ...代码... }) //document ready 简写 $(function()  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
